Creates a [Pub/Sub notification
configuration](https://docs.cloud.google.com/storage/docs/pubsub-notifications) for a given bucket.

## Required permissions

The authenticated user must have the `storage.buckets.update` IAM
permission to use this method.

## Request

### HTTP request

```
POST https://storage.googleapis.com/storage/v1/b/bucket/notificationConfigs
```

In addition to [standard query parameters](https://docs.cloud.google.com/storage/docs/json_api/v1/parameters.md.txt#query),
the following query parameters apply to this method.

To see an example of how to include query parameters in a request, see the
[JSON API Overview](https://docs.cloud.google.com/storage/docs/json_api.md.txt#query_parameters) page.

### Parameters

| Parameter name | Value | Description |
|---|---|---|
| **Path parameters** |||
| `bucket` | `string` | The parent bucket of the notification. |

### Request body

In the request body, supply a [notification
resource](https://docs.cloud.google.com/storage/docs/json_api/v1/notifications#resource) with the following properties:

| Property name | Value | Description | Notes |
|---|---|---|---|
| **Required Properties** ||||
| `topic` | `string` | The Pub/Sub topic to which this subscription publishes. Formatted as: `"//pubsub.googleapis.com/projects/PROJECT-IDENTIFIER/topics/TOPIC-NAME"` | writable |
| `payload_format` | `string` | The desired content of the Payload. <br /> Acceptable values are: - `"JSON_API_V1"` - `"NONE"` | writable |
| **Optional Properties** ||||
| `custom_attributes` | `object` | An optional list of additional attributes to attach to each Pub/Sub message published for this notification subscription. | writable |
| `event_types[]` | `list` | If present, only send notifications about listed [event types](https://docs.cloud.google.com/storage/docs/pubsub-notifications.md.txt#events). If empty, send notifications for all event types. | writable |
| `object_name_prefix` | `string` | If present, only apply this notification configuration to object names that begin with this prefix. | writable |

## Response

If successful, this method returns a [notification
resource](https://docs.cloud.google.com/storage/docs/json_api/v1/notifications#resource) in the response body.

## Try it!


Use the APIs Explorer below to call this method on live data and see the response.